summaryrefslogtreecommitdiff
path: root/ts/compile_flat_file.sh
diff options
context:
space:
mode:
authorBjörn Harrtell <bjornharrtell@users.noreply.github.com>2023-01-21 21:22:22 +0100
committerGitHub <noreply@github.com>2023-01-21 12:22:22 -0800
commitef76b5ece4d6ff06bebf04f42e41a50427263ae3 (patch)
treed91b74372601c7f4990f221b5722094021fdf729 /ts/compile_flat_file.sh
parent1703662285f5b2a2ee1a151b17755fd709ad2e13 (diff)
downloadflatbuffers-ef76b5ece4d6ff06bebf04f42e41a50427263ae3.tar.gz
flatbuffers-ef76b5ece4d6ff06bebf04f42e41a50427263ae3.tar.bz2
flatbuffers-ef76b5ece4d6ff06bebf04f42e41a50427263ae3.zip
[TS/JS] Entry point per namespace and reworked 1.x compatible single file build (#7510)
* [TS/JS] Entry point per namespace * Fix handling of outputpath and array_test * Attempt to fix generate_code * Fix cwd for ts in generate_code * Attempt to fixup bazel and some docs * Add --ts-flat-files to bazel build to get bundle * Move to DEFAULT_FLATC_TS_ARGS * Attempt to add esbuild * Attempt to use npm instead * Remove futile attempt to add esbuild * Attempt to as bazel esbuild * Shuffle * Upgrade bazel deps * Revert failed attempts to get bazel working * Ignore flatc tests for now * Add esbuild dependency * `package.json` Include esbuild * `WORKSPACE` Add fetching esbuild binary * Update WORKSPACE * Unfreeze Lockfile * Update WORKSPACE * Update BUILD.bazel * Rework to suggest instead of running external bundler * Add esbuild generation to test script * Prelim bundle test * Run test JavaScriptTest from flatbuffers 1.x * Deps upgrade * Clang format fix * Revert bazel changes * Fix newline * Generate with type declarations * Handle "empty" root namespace * Adjust tests for typescript_keywords.ts * Separate test procedure for old node resolution module output * Fix rel path for root level re-exports * Bazel support for esbuild-based flatc Unfortunately, we lose typing information because the new esbuild method of generating single files does not generate type information. The method used here is a bit hack-ish because it relies on parsing the console output of flatc to figure out what to do. * Try to fix bazel build for when node isn't present on host * Auto formatting fixes * Fix missing generated code Co-authored-by: Derek Bailey <derekbailey@google.com> Co-authored-by: James Kuszmaul <jabukuszmaul+collab@gmail.com>
Diffstat (limited to 'ts/compile_flat_file.sh')
-rwxr-xr-xts/compile_flat_file.sh23
1 files changed, 23 insertions, 0 deletions
diff --git a/ts/compile_flat_file.sh b/ts/compile_flat_file.sh
new file mode 100755
index 00000000..0aeaebea
--- /dev/null
+++ b/ts/compile_flat_file.sh
@@ -0,0 +1,23 @@
+#!/bin/bash
+# This is a script used by the typescript flatbuffer bazel rules to compile
+# a flatbuffer schema (.fbs file) to typescript and then use esbuild to
+# generate a single output.
+# Note: This relies on parsing the stdout of flatc to figure out how to
+# run esbuild.
+# --- begin runfiles.bash initialization v2 ---
+# Copy-pasted from the Bazel Bash runfiles library v2.
+set -uo pipefail; set +e; f=bazel_tools/tools/bash/runfiles/runfiles.bash
+source "${RUNFILES_DIR:-/dev/null}/$f" 2>/dev/null || \
+ source "$(grep -sm1 "^$f " "${RUNFILES_MANIFEST_FILE:-/dev/null}" | cut -f2- -d' ')" 2>/dev/null || \
+ source "$0.runfiles/$f" 2>/dev/null || \
+ source "$(grep -sm1 "^$f " "$0.runfiles_manifest" | cut -f2- -d' ')" 2>/dev/null || \
+ source "$(grep -sm1 "^$f " "$0.exe.runfiles_manifest" | cut -f2- -d' ')" 2>/dev/null || \
+ { echo>&2 "ERROR: cannot find $f"; exit 1; }; f=; set -e
+# --- end runfiles.bash initialization v2 ---
+set -e
+runfiles_export_envvars
+FLATC=$(rlocation com_github_google_flatbuffers/flatc)
+ESBUILD=$(rlocation npm/node_modules/esbuild/bin/esbuild)
+TS_FILE=$(${FLATC} $@ | grep "Entry point.*generated" | grep -o "bazel-out.*ts")
+export PATH=$(rlocation nodejs_linux_amd64/bin/nodejs/bin)
+${ESBUILD} ${TS_FILE} --format=cjs --bundle --outfile="${OUTPUT_FILE}" --external:flatbuffers --log-level=warning